package com.usky.system.controller.api;

import com.usky.common.core.bean.ApiResult;
import com.usky.common.core.util.BeanMapperUtils;
import com.usky.common.security.utils.SecurityUtils;
import com.usky.system.RemoteLogService;
import com.usky.system.domain.*;
import com.usky.system.mapper.SysCheckCodeMapper;
import com.usky.system.service.ISysLogininforService;
import com.usky.system.service.ISysOperLogService;
import com.usky.system.service.util.Operation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.UnsupportedEncodingException;

/**
 * @author yq
 * @date 2022/7/1 11:08
 */
@RequestMapping("/logApi")
@RestController
public class SysLogControllerApi implements RemoteLogService {

    @Autowired
    private ISysOperLogService sysOperLogService;

    @Autowired
    private ISysLogininforService sysLogininforService;

    @Autowired
    private SysCheckCodeMapper sysCheckCodeMapper;

    Operation operation = new Operation();

    @Override
    public ApiResult<Boolean> saveLog(SysOperLogVO sysOperLog) {
        SysCheckCode sysCheckCode = new SysCheckCode();
        //校验码存储
        sysCheckCode.setDeptId(SecurityUtils.getLoginUser().getSysUser().getDeptId());
        sysCheckCode.setUserId(SecurityUtils.getUserId());
        sysCheckCode.setTenantId(SecurityUtils.getTenantId());
        sysCheckCode.setUserName(SecurityUtils.getUsername());
        sysCheckCode.setCheckCodeType(4);
        sysCheckCode.setPlaintext(sysOperLog.getOperId().toString());
        try {
            sysCheckCode.setCheckCode(operation.CBCMAC((sysOperLog.getTitle() + sysOperLog.getBusinessType().toString() + sysOperLog.getMethod() + sysOperLog.getOperName()
                    + sysOperLog.getOperUrl() + sysOperLog.getOperIp() + sysOperLog.getOperTime().toString() + SecurityUtils.getTenantId().toString()).getBytes("UTF-8")));
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        sysCheckCodeMapper.insert(sysCheckCode);
        return ApiResult.success(sysOperLogService.save(BeanMapperUtils.map(sysOperLog, SysOperLog.class)));
    }

    @Override
    public ApiResult<Boolean> saveLogininfor(SysLogininforVO sysLogininfor) {
        SysCheckCode sysCheckCode = new SysCheckCode();
        //校验码存储
        sysCheckCode.setDeptId(SecurityUtils.getLoginUser().getSysUser().getDeptId());
        sysCheckCode.setUserId(SecurityUtils.getUserId());
        sysCheckCode.setTenantId(SecurityUtils.getTenantId());
        sysCheckCode.setUserName(SecurityUtils.getUsername());
        sysCheckCode.setCheckCodeType(3);
        sysCheckCode.setPlaintext(sysLogininfor.getInfoId().toString());
        try {
            sysCheckCode.setCheckCode(operation.CBCMAC((sysLogininfor.getUserName() + sysLogininfor.getIpaddr() + sysLogininfor.getStatus() + sysLogininfor.getMsg()
                    + sysLogininfor.getAccessTime().toString() + sysLogininfor.getDeptId().toString() + sysLogininfor.getTenantId().toString()).getBytes("UTF-8")));
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        sysCheckCodeMapper.insert(sysCheckCode);
        return ApiResult.success(sysLogininforService.save(BeanMapperUtils.map(sysLogininfor, SysLogininfor.class)));
    }
}
